<?php
/**
 * Created by JetBrains PhpStorm.
 * User: jorgefonseca
 * Date: 20/08/13
 * Time: 16:13
 * To change this template use File | Settings | File Templates.
 */

namespace Importacao\Logic\Bases\ModeloImportacao;

use Importacao\Logic\Partes;

class Migra {

    public $nrorg;
    public $nrempresa;
    public $dtMesCompetencia;

    public function __construct($nrorg, $dtMesCompetencia) {
        $this->nrorg            = $nrorg;
        $this->dtMesCompetencia = $dtMesCompetencia;
    }

    /**
     * @return mixed
     */
    public function getNrorg()
    {
        return $this->nrorg;
    }

    /**
     * @return mixed
     */
    public function getNrempresa()
    {
        return $this->nrempresa;
    }

    /**
     * Migra os registros de ocupação
     *
     * @param $registros
     *
     * @author leonardocarvalho 29/11/2013
     */
    public function migraOcupacao($registros) {

        $ocupacao = new Partes\Ocupacao($this->nrorg, $this->dtMesCompetencia);
        $ocupacao->migra($registros);

    }

    public function _persisteELog($tabela)
    {
        $nome = str_replace('Entity', '', get_class($tabela));
        /** @var $tabela TkEntity */
        if ($tabela) {
            $this->_logSePersistiu($tabela, $nome);
        } else {
            $this->_logChave('JaExistia'.$nome);
        }
    }

    /**
     * @param $tabela
     * @param $nome
     */
    public function _logSePersistiu($tabela, $nome)
    {
        /** @var $tabela TkEntity */
        if ($tabela->persist()) {
            $this->_logChave($nome);
        } else {
            $this->_logChave('NaoPersistido_' . $nome);
        }
    }

    /**
     * @param $nome
     */
    public function _logChave($nome)
    {
        if (isset($this->_log[$nome])) {
            $this->_log[$nome]++;
        } else {
            $this->_log[$nome] = 1;
        }
    }

    public function getLog() {
        return $this->_log;
    }

}

//function login($nmorganizacao, $cdfilial, $acesso, $senha) {
//    $login = new \LoginLogicProdutos($nmorganizacao, $cdfilial, $acesso, $senha);
//
//    \Ambiente::incluiVariaveisAmbiente($login);
//
//    $parametros = array(
//        'NRORG' => $login->getNrorg(),
//        'CDOPERADOR' => $login->getCdoperador()
//    );
//
//    $fpa = new \FpaLoginLogic($parametros);
//}
//
//require '../../../../../../source/mig/public/bootstrap.php';
//
//login('teknisa', 9999, 9999, $argv[1]);
//
//\FPA::setNrorgTrabalho(1005);
//
//$migra = new Migra(\FPA::getNrorgTrabalho(), \FPA::getDtCompetencia());
//
//$migra->migraFuncionario('A', 'Z');
