var TcoAuthListener = function(AuthRunner) {

    /**
     * Overwrite XMLHttpRequest.prototype.open
     * and add a listener on it.
     */
    this.initRoutesListener = function() {
        (function(open) {
            XMLHttpRequest.prototype.open = function(method, url, async, user, pass) {
                this.addEventListener("readystatechange", function() {
                    callFunction(this);
                }, false);

                open.call(this, method, url, async, user, pass);
            };
        })(XMLHttpRequest.prototype.open);
    };

    /**
     * Call AuthFunctions user-made function
     * to validate tco routes response.
     * 
     * @param {Response} response 
     */
    var callFunction = function(response) {
        AuthRunner.run(response);
    };
};
